Overview | Package | Class | Use | Tree | Serialized | Deprecated | Index | Help
| ABLE 2.3.0 07/13/2005 14:21:00
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.ibm.able.platform
Class RmiAgentLifeCycleServiceProxy

    java.lang.Object
      com.ibm.able.platform.RmiAgentLifeCycleServiceProxy

All Implemented Interfaces:
  AblePlatformService, AblePlatformServiceEventGenerator, AgentLifeCycleService, java.io.Serializable, javax.agent.service.Service

public class RmiAgentLifeCycleServiceProxy
extends java.lang.Object
implements AgentLifeCycleService, java.io.Serializable

An RMI Agent Lifecycle Service Proxy contains a reference to an RMI version of an Agent Lifecycle Service (known as the delegate); the proxy contains methods identical to the methods in the actual service such that when a method is called on the proxy, the proxy forwards the call on to the actual service, but the proxy

1. traps all RemoteExceptions that might be thrown by the service,
2. turns the RemoteExceptions into AgentLifeCycleFailure exceptions, and then
3. rethrows the new exception.

In this way, code making use of the proxy does not have to be sensitive to RMI RemoteExceptions and can code to a common Agent Lifecycle Service interface.

See Also:
  Serialized Form

Field Summary

Fields inherited from interface com.ibm.able.platform.AgentLifeCycleService
`COLUMN_NAMES, COLUMN_TYPES, CreatedAgentEntry, CreatedAgentName, SERVICE_TYPE, ServiceEventListener`

Constructor Summary
`RmiAgentLifeCycleServiceProxy(RmiAgentLifeCycleService theDelegate, java.rmi.registry.Registry theRegistry, java.lang.String theAddress)` Creates a proxy over the specified RMI reference to an Agent Lifecycle Service.

Method Summary
`void` | `addAblePlatformServiceEventListener(AblePlatformServiceEventListener theListener)` Adds a service event listener to this service.
`AblePlatformAgent` | `createAgentInstance(AbleAgentClassDescription theAgentClassDescription, java.lang.String theAgentPoolAlias, AbleSecureKey theSecureKey)` Creates an instance of an agent in a specified agent pool.
`AblePlatformAgent` | `createAgentInstanceAndInitialize(AbleAgentClassDescription theAgentClassDescription, java.lang.String theAgentPoolAlias, AbleSecureKey theSecureKey)` Creates an instance of an agent in a specified agent pool and initializes the agent using parameters found in the specified AbleAgentClassDescription.
`AblePlatformAgent` | `createAgentInstanceAndInitialize(AbleAgentClassDescription theAgentClassDescription, java.lang.String theAgentPoolAlias, java.lang.Object theInitArg, AbleSecureKey theSecureKey)` Creates an instance of an agent in a specified agent pool and initializes the agent using the specified parameters.
`java.util.Vector` | `getAblePlatformServiceEventListeners()` Gets a collection of all service event listeners registered with this service event generator.
`java.util.Vector` | `getCreatedAgents(AbleSecureKey theSecureKey)` Gets a collection of all AblePlatformAgent objects created by this particular Agent Lifecycle Service.
`AbleAgentClassDescription[]` | `getPermittedAgents()` Gets a collection of agents that are permitted to run on this platform.
`AbleAgentClassDescription[]` | `getPermittedAgents(java.lang.String propertyName, java.lang.String propertyValue)` Gets a collection of agents permitted to run on this platform with the property name and value provided.
`javax.agent.service.ServiceProperties` | `getServiceProperties()` Gets the service properties of the underlying service.
`int` | `getState()` Returns the state of this service.
`void` | `initializeAgent(AblePlatformAgent theAgent, AbleSecureKey theSecureKey)` Initializes a previously created agent.
`void` | `initializeAgent(AblePlatformAgent theAgent, java.lang.Object theInitArg, AbleSecureKey theSecureKey)` Initializes a previously created agent instance using the specified initialization argument.
`void` | `quiesceAgentPool(java.lang.String theAgentPoolAlias, AbleSecureKey theSecureKey)` Quiesces the specified agent pool by sending a `quitAgent` to each agent known to be running in the pool.
`void` | `quitAgent(javax.agent.service.directory.AgentDescription theAgentDescription, AbleSecureKey theSecureKey)` Requests the agent represented by the specified AgentDescription to quit itself along with any threads the agent owns and any other beans and agents the agent may contain.
`void` | `quitAgents(javax.agent.service.directory.AgentDescription[] theAgentDescriptionList, AbleSecureKey theSecureKey)` Requests each agent represented in the specified AgentDescription list to quit itself along with any threads the agent owns and any other beans and agents the agent may contain.
`void` | `recoverAgentPool(java.lang.String theAgentPoolAlias, AbleSecureKey theSecureKey)` Recovers the specified agent pool by recreating any missing agents that were originally created there.
`void` | `reinitializeAgent(javax.agent.service.directory.AgentDescription theAgentDescription, AbleSecureKey theSecureKey)`
`void` | `removeAblePlatformServiceEventListener(AblePlatformServiceEventListener theListener)` Removes a service event listener from this service.
`void` | `resetAgent(javax.agent.service.directory.AgentDescription theAgentDescription, AbleSecureKey theSecureKey)` Requests the agent represented by the specified AgentDescription to reset itself along with any threads the agent owns and any other beans and agents the agent may contain; however, the agent itself may decide whether to reset any internal agents and beans it may contain.
`void` | `resetAgents(javax.agent.service.directory.AgentDescription[] theAgentDescriptionList, AbleSecureKey theSecureKey)` Requests each agent represented in the specified AgentDescription list to reset itself along with any threads the agent owns and any other beans and agents the agent may contain.
`void` | `resumeAgent(javax.agent.service.directory.AgentDescription theAgentDescription, AbleSecureKey theSecureKey)` Requests the agent represented by the specified AgentDescription to resume itself along with any threads the agent owns and any other beans and agents the agent may contain; however, the agent itself may decide whether to resume any internal agents and beans it may contain.
`void` | `resumeAgents(javax.agent.service.directory.AgentDescription[] theAgentDescriptionList, AbleSecureKey theSecureKey)` Requests each agent represented in the specified AgentDescription list to resume itself along with any threads the agent owns and any other beans and agents the agent may contain.
`void` | `setServiceProperties(javax.agent.service.ServiceProperties theServiceProperties)` Sets the service properties of the underlying service.
`void` | `suspendAgent(javax.agent.service.directory.AgentDescription theAgentDescription, AbleSecureKey theSecureKey)` Requests the agent represented by the specified AgentDescription to suspend itself along with any threads the agent owns and any other beans and agents the agent may contain; however, the agent itself may decide whether to suspend any internal agents and beans it may contain.
`void` | `suspendAgents(javax.agent.service.directory.AgentDescription[] theAgentDescriptionList, AbleSecureKey theSecureKey)` Requests each agent represented in the specified AgentDescription list to suspend itself along with any threads the agent owns and any other beans and agents the agent may contain.
`void` | `terminateService(AbleSecureKey theSecureKey)` Terminates this service in a controlled way; the service is removed from the service root and, if necessary, unbound from the RMI registry and unexported as a remote RMI object.
`java.lang.String` | `toString()` Gets a string describing the contents of the object.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### RmiAgentLifeCycleServiceProxy

    public RmiAgentLifeCycleServiceProxy(RmiAgentLifeCycleService theDelegate,
                                         java.rmi.registry.Registry theRegistry,
                                         java.lang.String theAddress)

  Creates a proxy over the specified RMI reference to an Agent Lifecycle Service.

Parameters:
  `theDelegate` - A reference to an RMI version of an Agent Lifecycle Service.

  `theRegistry` - The RMI registry at which the above Agent Lifecycle Service is registered.

  `theAddress` - The RMI address at which the above Agent Lifecycle Service is registered.

Method Detail

### getServiceProperties

    public javax.agent.service.ServiceProperties getServiceProperties()

  Gets the service properties of the underlying service.

  Note: In this implementation, the method call is not forwarded on to the service; null is always returned.

  Specified by:
    `getServiceProperties` in interface `javax.agent.service.Service`
  Returns:
    null at all times.

### setServiceProperties

    public void setServiceProperties(javax.agent.service.ServiceProperties theServiceProperties)

  Sets the service properties of the underlying service.

  Note: In this implementation, the method call is not forwarded on to the service; the call is simply ignored.

  Specified by:
    `setServiceProperties` in interface `javax.agent.service.Service`
  Parameters:
    `theServiceProperties` - The service properties to be used by the service.

### getPermittedAgents

    public AbleAgentClassDescription[] getPermittedAgents()
                                                   throws AgentLifeCycleException,
                                                          AgentLifeCycleFailure

  Description copied from interface: `AgentLifeCycleService`
  Gets a collection of agents that are permitted to run on this platform.

  Specified by:
    `getPermittedAgents` in interface `AgentLifeCycleService`
  Returns:
    a collection of agent class descriptions, each of which defines an agent that can run somewhere in the platform. These are passed to `createAgentInstance` methods to create new instances of agents in the platform.
  Throws:
    `AgentLifeCycleFailure` - When there is a problem in the lifecycle infrastructure code.
    `AgentLifeCycleException` - On any Agent Lifecycle error.

### getPermittedAgents

    public AbleAgentClassDescription[] getPermittedAgents(java.lang.String propertyName,
                                                          java.lang.String propertyValue)
                                                   throws AgentLifeCycleException,
                                                          AgentLifeCycleFailure,
                                                          javax.agent.service.naming.NamingException

  Description copied from interface: `AgentLifeCycleService`
  Gets a collection of agents permitted to run on this platform with the property name and value provided.

  Specified by:
    `getPermittedAgents` in interface `AgentLifeCycleService`
  Parameters:
    `propertyName` -
    `propertyValue` -
  Returns:
    a collection of agent class descriptions, each of which defines an agent with the specified property and value that can run somewhere in the platform. These are passed to `createAgentInstance` methods to create new instances of agents in the platform.
  Throws:
    `AgentLifeCycleFailure` - When there is a problem in the lifecycle infrastructure code.
    `AgentLifeCycleException` - On any Agent Lifecycle error.
    `javax.agent.service.naming.NamingException`

### createAgentInstance

    public AblePlatformAgent createAgentInstance(AbleAgentClassDescription theAgentClassDescription,
                                                 java.lang.String theAgentPoolAlias,
                                                 AbleSecureKey theSecureKey)
                                          throws AgentLifeCycleException,
                                                 AgentLifeCycleFailure,
                                                 javax.agent.service.naming.NamingException

  Description copied from interface: `AgentLifeCycleService`
  Creates an instance of an agent in a specified agent pool.

  If the AbleAgentClassDescription contains constructor parameters, a constructor that matches the parameters will be used, if found. Otherwise, the agent's null argument constructor is used.

  The agent is constructed, but not initialized; initialization must be performed as a separate step by calling one of the `initializeAgent` methods.

  Specified by:
    `createAgentInstance` in interface `AgentLifeCycleService`
  Parameters:
    `theAgentClassDescription` - A class description obtained from the `AgentLifeCycleService.getPermittedAgents()` method. The specified class description is verified that it is one from Agent Lifecycle's internal permitted agent list so that it cannot be spoofed.

    `theAgentPoolAlias` - Specifies in which of the agent's eligible agent pools (defined in the platform preference file) the agent is to be created. The specified agent pool is verified against the agent's class description, so that an agent cannot be created in an agent pool in which it is not allowed to run.

    `theSecureKey` - Used when security is on to make sure that the caller is authentic and has the authority to perform the operation; may be null when security is off.

  Returns:
    an AblePlatformAgent remote interface reference to the newly created agent.
  Throws:
    `AgentLifeCycleFailure` - When there is a problem in the lifecycle infrastructure code.
    `AgentLifeCycleException` -

    If the AbleAgentClassDescription is null.

    If the AbleAgentClassDescription does not exist in the service's actual permitted agent list; that is, the AbleAgentClassDescription appears to have been spoofed.

    If the specified agent pool name is not a valid agent pool for the AbleAgentClassDescription.

    If the agent represented by the AbleAgentClassDescription is not an AblePlatformAgent.

    `javax.agent.service.naming.NamingException` - On any Agent Naming Service error.

### createAgentInstanceAndInitialize

    public AblePlatformAgent createAgentInstanceAndInitialize(AbleAgentClassDescription theAgentClassDescription,
                                                              java.lang.String theAgentPoolAlias,
                                                              AbleSecureKey theSecureKey)
                                                       throws AgentLifeCycleException,
                                                              AgentLifeCycleFailure,
                                                              javax.agent.service.naming.NamingException

  Description copied from interface: `AgentLifeCycleService`
  Creates an instance of an agent in a specified agent pool and initializes the agent using parameters found in the specified AbleAgentClassDescription.

  If the AbleAgentClassDescription contains constructor parameters, a constructor that matches the parameters will be used, if found. Otherwise, the agent's null argument constructor is used.

  If the AbleAgentClassDescription contains intialization parameters, those parameters are packaged into an Object[] that is used to intialize the agent; otherwise, the agent is initialized without any special parameters.

  Specified by:
    `createAgentInstanceAndInitialize` in interface `AgentLifeCycleService`
  Parameters:
    `theAgentClassDescription` - A class description obtained from the `AgentLifeCycleService.getPermittedAgents()` method. The specified class description is verified that it is one from Agent Lifecycle's internal permitted agent list so that it cannot be spoofed.

    `theAgentPoolAlias` - Specifies in which of the agent's eligible agent pools (defined in the platform preference file) the agent is to be created. The specified agent pool is verified against the agent's class description, so that an agent cannot be created in an agent pool in which it is not allowed to run.

    `theSecureKey` - Used when security is on to make sure that the caller is authentic and has the authority to perform the operation; may be null when security is off.

  Returns:
    an AblePlatformAgent remote interface reference to the newly created agent.
  Throws:
    `javax.agent.service.naming.NamingException` - On any Agent Naming Service error.
    `AgentLifeCycleFailure` - If the agent cannot be created.
    `AgentLifeCycleException` -

    If the AbleAgentClassDescription is null.

    If the AbleAgentClassDescription does not exist in the service's actual permitted agent list; that is, the AbleAgentClassDescription appears to have been spoofed.

    If the specified agent pool name is not a valid agent pool for the AbleAgentClassDescription.

    If the agent represented by the AbleAgentClassDescription is not an AblePlatformAgent.

### createAgentInstanceAndInitialize

    public AblePlatformAgent createAgentInstanceAndInitialize(AbleAgentClassDescription theAgentClassDescription,
                                                              java.lang.String theAgentPoolAlias,
                                                              java.lang.Object theInitArg,
                                                              AbleSecureKey theSecureKey)
                                                       throws AgentLifeCycleException,
                                                              AgentLifeCycleFailure,
                                                              javax.agent.service.naming.NamingException

  Description copied from interface: `AgentLifeCycleService`
  Creates an instance of an agent in a specified agent pool and initializes the agent using the specified parameters.

  If the AbleAgentClassDescription contains constructor parameters, a constructor that matches the parameters will be used, if found. Otherwise, the agent's null argument constructor is used.

  Specified by:
    `createAgentInstanceAndInitialize` in interface `AgentLifeCycleService`
  Parameters:
    `theAgentClassDescription` - A class description obtained from the `AgentLifeCycleService.getPermittedAgents()` method. The specified class description is verified that it is one from Agent Lifecycle's internal permitted agent list so that it cannot be spoofed.

    `theAgentPoolAlias` - Specifies in which of the agent's eligible agent pools (defined in the platform preference file) the agent is to be created. The specified agent pool is verified against the agent's class description, so that an agent cannot be created in an agent pool in which it is not allowed to run.

    `theInitArg` - If the initialization parameter is not null, the agent is initialized using the specified initialization parameter; otherwise, the agent is initialized without any special parameters.

    `theSecureKey` - Used when security is on to make sure that the caller is authentic and has the authority to perform the operation; may be null when security is off.

  Returns:
    an AblePlatformAgent remote interface reference to the newly created agent.
  Throws:
    `javax.agent.service.naming.NamingException` - On any Agent Naming Service error.
    `AgentLifeCycleFailure` - When there is a problem in the lifecycle infrastructure code.
    `AgentLifeCycleException` -

    If the AbleAgentClassDescription is null.

    If the AbleAgentClassDescription does not exist in the service's actual permitted agent list; that is, the AbleAgentClassDescription appears to have been spoofed.

    If the specified agent pool name is not a valid agent pool for the AbleAgentClassDescription.

    If the agent represented by the AbleAgentClassDescription is not an AblePlatformAgent.

### initializeAgent

    public void initializeAgent(AblePlatformAgent theAgent,
                                AbleSecureKey theSecureKey)
                         throws AgentLifeCycleException,
                                AgentLifeCycleFailure,
                                javax.agent.service.naming.NamingException

  Description copied from interface: `AgentLifeCycleService`
  Initializes a previously created agent. The agent is initialized without any special parameters.

  Specified by:
    `initializeAgent` in interface `AgentLifeCycleService`
  Parameters:
    `theAgent` - The agent to initialize.

    `theSecureKey` - Used when security is on to make sure that the caller is authentic and has the authority to perform the operation; may be null when security is off.

  Throws:
    `javax.agent.service.naming.NamingException` - On any Agent Naming Service error.
    `AgentLifeCycleException` - On any Agent Lifecycle error.
    `AgentLifeCycleFailure` - When there is a problem in the lifecycle infrastructure code.

### initializeAgent

    public void initializeAgent(AblePlatformAgent theAgent,
                                java.lang.Object theInitArg,
                                AbleSecureKey theSecureKey)
                         throws AgentLifeCycleException,
                                AgentLifeCycleFailure,
                                javax.agent.service.naming.NamingException

  Description copied from interface: `AgentLifeCycleService`
  Initializes a previously created agent instance using the specified initialization argument.

  Specified by:
    `initializeAgent` in interface `AgentLifeCycleService`
  Parameters:
    `theAgent` - The agent to initialize.

    `theInitArg` - The initialization argument; typically this is an Object[] array, but depends on each agent's init method.

    `theSecureKey` - Used when security is on to make sure that the caller is authentic and has the authority to perform the operation; may be null when security is off.

  Throws:
    `AgentLifeCycleException` - On any Agent Lifecycle error.
    `AgentLifeCycleFailure` - When there is a problem in the lifecycle infrastructure code.
    `javax.agent.service.naming.NamingException` - On any Agent Naming Service error.

### reinitializeAgent

    public void reinitializeAgent(javax.agent.service.directory.AgentDescription theAgentDescription,
                                  AbleSecureKey theSecureKey)
                           throws AgentLifeCycleException,
                                  AgentLifeCycleFailure,
                                  javax.agent.service.naming.NamingException

  Throws:
    `AgentLifeCycleException`
    `AgentLifeCycleFailure`
    `javax.agent.service.naming.NamingException`

### quitAgent

    public void quitAgent(javax.agent.service.directory.AgentDescription theAgentDescription,
                          AbleSecureKey theSecureKey)
                   throws AgentLifeCycleException,
                          AgentLifeCycleFailure,
                          javax.agent.service.naming.NamingException

  Description copied from interface: `AgentLifeCycleService`
  Requests the agent represented by the specified AgentDescription to quit itself along with any threads the agent owns and any other beans and agents the agent may contain.

  Specified by:
    `quitAgent` in interface `AgentLifeCycleService`
  Parameters:
    `theAgentDescription` - The agent to quit.

    `theSecureKey` - Used when security is on to make sure that the caller is authentic and has the authority to perform the operation; may be null when security is off.

  Throws:
    `javax.agent.service.naming.NamingException` - On any Agent Naming Service error.
    `AgentLifeCycleFailure` - When there is a problem in the lifecycle infrastructure code.
    `AgentLifeCycleException` - On any Agent Lifecycle error.

### quitAgents

    public void quitAgents(javax.agent.service.directory.AgentDescription[] theAgentDescriptionList,
                           AbleSecureKey theSecureKey)
                    throws AgentLifeCycleException,
                           AgentLifeCycleFailure,
                           javax.agent.service.naming.NamingException

  Description copied from interface: `AgentLifeCycleService`
  Requests each agent represented in the specified AgentDescription list to quit itself along with any threads the agent owns and any other beans and agents the agent may contain.

  Specified by:
    `quitAgents` in interface `AgentLifeCycleService`
  Parameters:
    `theAgentDescriptionList` - The agents to quit.

    `theSecureKey` - Used when security is on to make sure that the caller is authentic and has the authority to perform the operation; may be null when security is off.

  Throws:
    `AgentLifeCycleFailure` - When there is a problem in the lifecycle infrastructure code.
    `javax.agent.service.naming.NamingException` - On any Agent Naming Service error.
    `AgentLifeCycleException` - On any Agent Lifecycle error.

### suspendAgent

    public void suspendAgent(javax.agent.service.directory.AgentDescription theAgentDescription,
                             AbleSecureKey theSecureKey)
                      throws AgentLifeCycleException,
                             AgentLifeCycleFailure,
                             javax.agent.service.naming.NamingException

  Description copied from interface: `AgentLifeCycleService`
  Requests the agent represented by the specified AgentDescription to suspend itself along with any threads the agent owns and any other beans and agents the agent may contain; however, the agent itself may decide whether to suspend any internal agents and beans it may contain.

  Specified by:
    `suspendAgent` in interface `AgentLifeCycleService`
  Parameters:
    `theAgentDescription` - The agent to suspend.

    `theSecureKey` - Used when security is on to make sure that the caller is authentic and has the authority to perform the operation; may be null when security is off.

  Throws:
    `AgentLifeCycleException` - On any Agent Lifecycle error.
    `AgentLifeCycleFailure` - When there is a problem in the lifecycle infrastructure code.
    `javax.agent.service.naming.NamingException` - On any Agent Naming Service error.

### suspendAgents

    public void suspendAgents(javax.agent.service.directory.AgentDescription[] theAgentDescriptionList,
                              AbleSecureKey theSecureKey)
                       throws AgentLifeCycleException,
                              AgentLifeCycleFailure,
                              javax.agent.service.naming.NamingException

  Description copied from interface: `AgentLifeCycleService`
  Requests each agent represented in the specified AgentDescription list to suspend itself along with any threads the agent owns and any other beans and agents the agent may contain.

  Specified by:
    `suspendAgents` in interface `AgentLifeCycleService`
  Parameters:
    `theAgentDescriptionList` - The agents to suspend.

    `theSecureKey` - Used when security is on to make sure that the caller is authentic and has the authority to perform the operation; may be null when security is off.

  Throws:
    `AgentLifeCycleException` - On any Agent Lifecycle error.
    `AgentLifeCycleFailure` - When there is a problem in the lifecycle infrastructure code.
    `javax.agent.service.naming.NamingException` - On any Agent Naming Service error.

### resumeAgent

    public void resumeAgent(javax.agent.service.directory.AgentDescription theAgentDescription,
                            AbleSecureKey theSecureKey)
                     throws AgentLifeCycleException,
                            AgentLifeCycleFailure,
                            javax.agent.service.naming.NamingException

  Description copied from interface: `AgentLifeCycleService`
  Requests the agent represented by the specified AgentDescription to resume itself along with any threads the agent owns and any other beans and agents the agent may contain; however, the agent itself may decide whether to resume any internal agents and beans it may contain.

  Specified by:
    `resumeAgent` in interface `AgentLifeCycleService`
  Parameters:
    `theAgentDescription` - The agent to resume.

    `theSecureKey` - Used when security is on to make sure that the caller is authentic and has the authority to perform the operation; may be null when security is off.

  Throws:
    `AgentLifeCycleException` - On any Agent Lifecycle error.
    `AgentLifeCycleFailure` - When there is a problem in the lifecycle infrastructure code.
    `javax.agent.service.naming.NamingException` - On any Agent Naming Service error.

### resumeAgents

    public void resumeAgents(javax.agent.service.directory.AgentDescription[] theAgentDescriptionList,
                             AbleSecureKey theSecureKey)
                      throws AgentLifeCycleException,
                             AgentLifeCycleFailure,
                             javax.agent.service.naming.NamingException

  Description copied from interface: `AgentLifeCycleService`
  Requests each agent represented in the specified AgentDescription list to resume itself along with any threads the agent owns and any other beans and agents the agent may contain.

  Specified by:
    `resumeAgents` in interface `AgentLifeCycleService`
  Parameters:
    `theAgentDescriptionList` - The agents to resume.

    `theSecureKey` - Used when security is on to make sure that the caller is authentic and has the authority to perform the operation; may be null when security is off.

  Throws:
    `AgentLifeCycleException` - On any Agent Lifecycle error.
    `AgentLifeCycleFailure` - When there is a problem in the lifecycle infrastructure code.
    `javax.agent.service.naming.NamingException` - On any Agent Naming Service error.

### resetAgent

    public void resetAgent(javax.agent.service.directory.AgentDescription theAgentDescription,
                           AbleSecureKey theSecureKey)
                    throws AgentLifeCycleException,
                           AgentLifeCycleFailure,
                           javax.agent.service.naming.NamingException

  Description copied from interface: `AgentLifeCycleService`
  Requests the agent represented by the specified AgentDescription to reset itself along with any threads the agent owns and any other beans and agents the agent may contain; however, the agent itself may decide whether to reset any internal agents and beans it may contain.

  Specified by:
    `resetAgent` in interface `AgentLifeCycleService`
  Parameters:
    `theAgentDescription` - The agent to reset.

    `theSecureKey` - Used when security is on to make sure that the caller is authentic and has the authority to perform the operation; may be null when security is off.

  Throws:
    `AgentLifeCycleFailure` - When there is a problem in the lifecycle infrastructure code.
    `javax.agent.service.naming.NamingException` - On any Agent Naming Service error.
    `AgentLifeCycleException` - On any Agent Lifecycle error.

### resetAgents

    public void resetAgents(javax.agent.service.directory.AgentDescription[] theAgentDescriptionList,
                            AbleSecureKey theSecureKey)
                     throws AgentLifeCycleException,
                            AgentLifeCycleFailure,
                            javax.agent.service.naming.NamingException

  Description copied from interface: `AgentLifeCycleService`
  Requests each agent represented in the specified AgentDescription list to reset itself along with any threads the agent owns and any other beans and agents the agent may contain.

  Specified by:
    `resetAgents` in interface `AgentLifeCycleService`
  Parameters:
    `theAgentDescriptionList` - The agents to reset.

    `theSecureKey` - Used when security is on to make sure that the caller is authentic and has the authority to perform the operation; may be null when security is off.

  Throws:
    `javax.agent.service.naming.NamingException` - On any Agent Naming Service error.
    `AgentLifeCycleFailure` - When there is a problem in the lifecycle infrastructure code.
    `AgentLifeCycleException` - On any Agent Lifecycle error.

### getCreatedAgents

    public java.util.Vector getCreatedAgents(AbleSecureKey theSecureKey)
                                      throws AgentLifeCycleException,
                                             AgentLifeCycleFailure,
                                             javax.agent.service.naming.NamingException

  Description copied from interface: `AgentLifeCycleService`
  Gets a collection of all AblePlatformAgent objects created by this particular Agent Lifecycle Service.

  Specified by:
    `getCreatedAgents` in interface `AgentLifeCycleService`
  Parameters:
    `theSecureKey` - Used when security is on to make sure that the caller is authentic and has the authority to perform the operation; may be null when security is off.

  Returns:
    A collection of Object arrays.

    Each element of the collection is an Object[n] object.

    Each element of that is

    - [0] - (AbleAgentClassDescription) The AbleAgentClassDescription used to create the agent.
    - [1] - (String) The selected agent pool alias in which the agent was created.
    - [2] - (String) The system's IP name or address that was used to reach the agent pool.
    - [3] - (String) The system's port that was used.
    - [4] - (String) The fully qualified class name of the agent.
    - [5] - (Object) A reference to the created agent; this can be cast to the AblePlatformAgent interface.
    - [6] - (String) The globally unique AgentName of the agent.
    - [7] - (Boolean) A flag indicating whether the agent was initialzed by the Lifecycle Service
    - [8] - (Object) If initialized, any initialization arguments used.

      The collection may be empty, but not null.

  Throws:
    `AgentLifeCycleException` - On any Agent Lifecycle error.
    `javax.agent.service.naming.NamingException` - On any Agent Naming Service error.
    `AgentLifeCycleFailure` - When there is a problem in the lifecycle infrastructure code.

### quiesceAgentPool

    public void quiesceAgentPool(java.lang.String theAgentPoolAlias,
                                 AbleSecureKey theSecureKey)
                          throws AgentLifeCycleException,
                                 AgentLifeCycleFailure,
                                 javax.agent.service.naming.NamingException

  Description copied from interface: `AgentLifeCycleService`
  Quiesces the specified agent pool by sending a `quitAgent` to each agent known to be running in the pool.

  Note that there is nothing that prevents new agents from being created in the pool during the time the pool is being quiesced.

  Specified by:
    `quiesceAgentPool` in interface `AgentLifeCycleService`
  Parameters:
    `theAgentPoolAlias` - The name of an agent pool defined in the platform preference file.

    `theSecureKey` - Used when security is on to make sure that the caller is authentic and has the authority to perform the operation; may be null when security is off.

  Throws:
    `AgentLifeCycleFailure` - When there is a problem in the lifecycle infrastructure code.
    `AgentLifeCycleException` - On any Agent Lifecycle error.
    `javax.agent.service.naming.NamingException` - On any Agent Naming Service error.

### recoverAgentPool

    public void recoverAgentPool(java.lang.String theAgentPoolAlias,
                                 AbleSecureKey theSecureKey)
                          throws AgentLifeCycleException,
                                 AgentLifeCycleFailure,
                                 javax.agent.service.naming.NamingException

  Description copied from interface: `AgentLifeCycleService`
  Recovers the specified agent pool by recreating any missing agents that were originally created there.

  Specified by:
    `recoverAgentPool` in interface `AgentLifeCycleService`
  Parameters:
    `theAgentPoolAlias` - The name of an agent pool defined in the platform preference file.

    `theSecureKey` - Used when security is on to make sure that the caller is authentic and has the authority to perform the operation; may be null when security is off.

  Throws:
    `javax.agent.service.naming.NamingException` - On any Agent Naming Service error.
    `AgentLifeCycleFailure` - When there is a problem in the lifecycle infrastructure code.
    `AgentLifeCycleException` - On any Agent Lifecycle error.

### terminateService

    public void terminateService(AbleSecureKey theSecureKey)
                          throws AbleException,
                                 javax.agent.service.naming.NamingException

  Description copied from interface: `AblePlatformService`
  Terminates this service in a controlled way; the service is removed from the service root and, if necessary, unbound from the RMI registry and unexported as a remote RMI object.

  Specified by:
    `terminateService` in interface `AblePlatformService`
  Parameters:
    `theSecureKey` - When security if off, this may be null as the parameter is ignored; when security is on the security key must be from an object with equal or greater authority in order for the operation to proceed.

  Throws:
    `javax.agent.service.naming.NamingException` - On any naming error.
    `AbleException` - On any remote error or Able error.

### getState

    public int getState()
                 throws AbleException

  Description copied from interface: `AblePlatformService`
  Returns the state of this service.

  Specified by:
    `getState` in interface `AblePlatformService`
  Returns:
    The state of this service.
  Throws:
    `AbleException` - On any remote error or Able error.

### addAblePlatformServiceEventListener

    public void addAblePlatformServiceEventListener(AblePlatformServiceEventListener theListener)
                                             throws AbleException

  Description copied from interface: `AblePlatformServiceEventGenerator`
  Adds a service event listener to this service.

  Specified by:
    `addAblePlatformServiceEventListener` in interface `AblePlatformServiceEventGenerator`
  Parameters:
    `theListener` - Any object interested in listening for service events generated by this service.

  Throws:
    `AbleException` - If the listener to be added is null, or on any error.

### removeAblePlatformServiceEventListener

    public void removeAblePlatformServiceEventListener(AblePlatformServiceEventListener theListener)
                                                throws AbleException

  Description copied from interface: `AblePlatformServiceEventGenerator`
  Removes a service event listener from this service.

  Specified by:
    `removeAblePlatformServiceEventListener` in interface `AblePlatformServiceEventGenerator`
  Parameters:
    `theListener` - A previously registered object that is no longer interested in listening for service events generated by this service.

  Throws:
    `AbleException` - If the listener to be removed is null, or on any error.

### getAblePlatformServiceEventListeners

    public java.util.Vector getAblePlatformServiceEventListeners()
                                                          throws AbleException

  Description copied from interface: `AblePlatformServiceEventGenerator`
  Gets a collection of all service event listeners registered with this service event generator.

  Specified by:
    `getAblePlatformServiceEventListeners` in interface `AblePlatformServiceEventGenerator`
  Returns:
    All registered AblePlatformServiceEventListener objects.
  Throws:
    `AbleException` - On any error.

### toString

    public java.lang.String toString()

  Gets a string describing the contents of the object.

  Returns:
    A string containing the current contents of the object.

Overview | Package | Class | Use | Tree | Serialized | Deprecated | Index | Help
| ABLE 2.3.0 07/13/2005 14:21:00
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

(C) Copyright IBM Corporation 1999, 2005